# -*- sh -*-
# The menu level, that sets up variable and launch the game.
# 


# load level resources
print "loading menu"
bg0.load "spritey.spr"
bg0.map "assault0.map" 128 128 # (appleman @ 576 280)
print "activating background"
bg1.map = bg0.map:1 128 128
bg2.load "aahowto.spr"
bg2.map embedded 224 160
print "loading sprites"
spr.load "spritey.spr":1

# pages : [0]Bilou, [1]Bilou again, [2]cliff&bush&apple, [3]anims & woodworm
#         [4]appleman&fruitbat, [5] caves, [6]tree, [7]leaves, [8]



# apple animation.
anim5 c {
  spr0 0
  delay 5
  spr0 1
  delay 10
  spr0 0
  delay 5
  spr0 2
  delay 10
  loop
}
print "animating blocks"
bg0.anim 220 : anim5
# ^ here, we link a previously defined animation to a specific block in VRAM
#   so that you have a background, animated object.


# game counters. See ASSAULT1.CMD for details.
let c0 = 1  # level
let c1 = 16 # required apples
let c2 = 5  # hitpoints
let c3 = 0  # lives
c2.action = track(37) {
@4: debug(row4)
#@16: fade(219)
@32: level(assault0.cmd, 1 ~ )
}
# the 'pound' sign  is a special counter for the score. it consumes the top-of-stack.
#  if a positive value is on top of the stack, the value is added to the score, but
#  a negative value resets the score to 0.


# level exit. Hack using a counter for now.
let c4 = 1
c4.action = track(0) {
@0: fade(219)
@16: level(assault1.cmd,i3i3i3i3i3 1 ~ )
# nothing else will be executed beyond this point
}


print "declaring state machine"

# Woodworm

input "worm.cmd"
import state0..1
using sound(5,60) as 0


#########################################################################################
## SPECIAL BLOCKS
## the level editor allows special blocks to be defined through tile types 0-3. A square
##  of 2x2 tiles aligned on a block is extended into a 0-255 value that identifies the 
##  special block's kind. The Apple Assault game doesn't need those blocks, but they are 
##  used on the menu

## "apple block"
#   used to clear apple blocks on contact. They trigger a sound (x0) and
#   increase the game difficulty by advancing level counter (i0) and decreasing
#   inter-appleman delay (d8).
block 01 {
   area (4,4)-(12,12) 0010
   on hit [t] (x0i0i0i0i0i0d8d8d8i7i7i7) 
}

## "exit target"
#   placed in the tree stump. By decreasing counter 4 on contact, it makes the level end.
block 83 {
  area (0,0)-(16,16) 0010
  on hit [t] (d4)
}

input "abilou.cmd"
import state 4..5

print "yo"
gob0 :state4 (128, 128) h
focus=gob0

using shgob(state0:=D) as 6

let c7 = 3      # applemen count
let c5 = 3
let c8 = 8     # inter-gob delay

input "appleman.cmd"
import state6
using shgob(state0 is e:=D) as 9
gob2 :state1 (48, 184) e

input "appshoot.cmd"
import state7..8

gob3 :state8 (64, 0) e

do fade(0)

print "  ** Code & Gfx by PypeBros **  "
print "  Sound & Music by  Cyb0rgJeff  "


zik.track(27)
print "go!"
end

