# Bilou falls
anim0 1 {
  spr0 1d
  delay 4
  spr0 1e
  delay 60
  done
}

anim6 0 {
  spr0 8
  delay 2
  done
}

statT2 :anim6{ # level clear
  using gravity(24,1536,4)
}

statT42 :anim6 {
  using gravity(24,1536,4)
}

statT2->statT42 on done (512 ~ :1)
statT2->statT42 on fail (512 ~ :1)
statT42->statT42 on fail (512 ~ :1)


# Bilou idle
anim8 1 {
  spr0 4
  delay 60
  spr0 7
  delay 120
  done
}

# Bilou jumps
anim9 1 {
  spr0 1c
  delay 6
  done
}

# Bilou jumps (to the left)
anim10 1 {
  spr0 401c
  delay 8
  done
}

# Bilou falls (to the left)
anim11 1 {
  spr0 401d
  delay 4
  spr0 401e
  delay 40
  done
}

# Bilou idle (to the left)
anim12 1 {
  spr0 4004
  delay 60
  spr0 4007
  delay 120
  done
}

# Bilou walks (to the right)
anim13 1 {
  spr0 20
  move 2 *
  spr0 21
  move 2 *
  spr0 22 
  move 2 *
  spr0 23
  move 2 *
  spr0 24
  move 2 *
  spr0 25
  move 2 *
  spr0 26
  move 2 *
  spr0 27
  move 2 *
  delay 1
  loop
}

# Bilou walks (to the left)
anim14 1 {
  spr0 4020
  move -2 *
  spr0 4021
  move -2 *
  spr0 4022 
  move -2 *
  spr0 4023
  move -2 *
  spr0 4024
  move -2 *
  spr0 4025
  move -2 *
  spr0 4026
  move -2 *
  spr0 4027
  move -2 *
  loop
}

## STATES 
# jump06-07  walk20-23  push22-25 hit!15-16 star18-19
# fall00-01  idle04-05            pwnd17    pnch28-29

# Bilou falling
statF0 :anim0 {
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 0 (2,2)-(14,14) 0011
  test 0 (0,12)-(16,16) 80000002
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

# Bilou idle
statI4 :anim8 {
  using dpad
  using stopper
  area 0 (2,2)-(14,14) 0013 # takes hits, bonus and stomps
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

statI4->statI4 on done [v6 0 >] (v6 4 - :6)

# Bilou jumping
statJ6 :anim9 {
  using dpad
  using momentum(256,64)
  using gravity(24,1536)
  area 0 (2,2)-(14,14) 0011  # takes hits and bonus
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

# Bilou jumping (to the left)
statJ7 :anim10 {
  using dpad
  using momentum(256,64)
  using gravity(24,1536)
  area 0 (2,2)-(14,14) 0011
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

# Bilou falling (left)
statF1 :anim11 {
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 0 (2,2)-(14,14) 0011
  test 0 (0,12)-(16,16) 80000002
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

# Bilou idle (left)
statI5 :anim12 {
  using dpad
  using stopper
  using momentum(256,64)
#  using decrease (v6 by 1 to 0) # better use your punch bonus soon.
  area 0 (2,2)-(14,14) 0013
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

statI5->statI5 on done [v6 0 >] (v6 4 - :6)


statW20 :anim13 {
  using dpad
  using momentum(256,128)
  using walker
  selfmove
  testpoint on (4,16)
  testpoint nw (16,12)
  area 0 (2,2)-(14,14) 0013 # takes hits, bonus, and stomps.
  area 1 (7,7)-(8,8)   0004 # activates traps.
}

statP22 :anim8 {
   using dpad
   using momentum(256,16)
   using walker
   testpoint on (4,16)
   testpoint nw(16,12)
  area 0 (2,2)-(14,14) 0013 # takes hits, bonus, and stomps.
  area 1 (7,7)-(8,8)   0004 # activates traps.
}
  

statW23 :anim14 {
  using dpad
  using momentum(256,128)
  using walker
  selfmove
  testpoint on (12,16)
  testpoint nw (-1,12)
  area 0 (2,2)-(14,14) 0013
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

statP25 :anim12 {
  using dpad
  using momentum(256,16)
  using walker
  testpoint on (12,16)
  testpoint nw (-1,12)
  area 0 (2,2)-(14,14) 0013
  area 1 (7,7)-(8,8) 0004 # activates traps.
}  

anim2 1 { # hit
  spr0 19
  done
}

anim3 1 {
  spr0 4019
  done
}

anim4 0 { # dodge
  spr0 14
  delay 2
  spr0 7
  done
}

anim5 0 {
  spr0 4014
  delay 2
  spr0 4007
  done
}

# Bilou dodge
statD14 :anim4 {
  using dpad
  using stopper
}
statD13 :anim5 {
  using dpad
  using stopper
}

statE12 :anim0 { # evasive move A
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 1 (7,7)-(8,8) 0004 # activates traps.
}
statE11 :anim11 { # evasive move A
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

statE10 :anim0 { # evasive move B
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 1 (7,7)-(8,8) 0004 # activates traps.
}
statE9 :anim11 { # evasive move B
  using dpad
  using momentum(256,64)
  using gravity(24,1536,4)
  area 1 (7,7)-(8,8) 0004 # activates traps.
}

# Bilou hit (right)
statH15 :anim2 {
  using nopad
  using momentum(256,64)
  using gravity(24,1536)
}

statH16 :anim3 {
  using nopad
  using momentum(256,64)
  using gravity(24,1536)
}

anim16 1 { # stomped.
  spr0 1b
  delay 30
  spr0 29
  delay 27
  spr0 1a
  delay 3
  done
}

#stomped.
statS17 :anim16 {
  using stopper
  area 0 (2,12)-(14,16)
}

statT3 :anim16 { # dead.
  using gravity(24,1536,4)
}



# a little star
anim19 4 {
  spr0 18
  delay 4
  spr0 19
  delay 4
  spr0 1a
  delay 4
  spr0 1b
  delay 4
  loop
}

anim20 4 { # a strike
  spr0 1d
  delay 1
  move 8 0
  delay 2
  spr0 1e
  move 2 0
  delay 2
  spr0 1f
  delay 2
  done
}

anim21 4 {
  spr0 401d
  delay 1
  move -8 0
  delay 2
  spr0 401e
  move -2 0
  delay 2
  spr0 401f
  delay 2
  done
}


anim22 4 {
  spr0 16
  move 8 0
  delay 1
  move 4 -4
  delay 1
  move 4 4
  check
  delay 1
  move 0 4
  check
  delay 1
  move 0 4
  check
  delay 1
  move -4 4
  check
  delay 1
  move -4 0
  check
  delay 1
  move -4 0  
  check
  delay 1
  done
}
anim23 4 {
  spr0 4016
  move -8 0
  delay 1
  move -4 -4
  delay 1
  move -4 4
  check
  delay 1
  move 0 4
  check
  delay 1
  move 0 4
  check
  delay 1
  move 4 4
  check
  delay 1
  move 4 0
  check
  delay 1
  move 4 0  
  check
  delay 1
  done
}

anim25 4 {
  spr0 4015
  move 0 0
  delay 2
  spr0 4015
  delay 4
  spr0 4016
  move 0 4
  delay 8
  done
}  

anim24 4 {
  spr0 15
  move 0 0
  delay 2
  spr0 15
  delay 4
  spr0 16
  move 0 4
  delay 8
  done
}  

# pitchenette
anim26 4 { 
  spr0 17
  move 8 0
  delay 2
  move 4 0
  delay 2
  move 2 0
  delay 2
  move 1 0
  delay 6
  done
}
anim27 4 { 
  spr0 4017
  move -8 0
  delay 2
  move -4 0
  delay 2
  move -2 0
  delay 2
  move -1 0
  delay 6
  done
}

state18 :anim19 { 
  using freemove               # shuriken
  test 0 (4,4)-(8,8) 80000008  # is a weapon.
}
state18->nil on fail [t]
using shgob(state18:= 0 :1 v6 :0) as 8


statp34 :anim26 {
  area 0 (6,6)-(12,10) 0001
}
statp35 :anim27 {
  area 0 (4,6)-(10,10) 0001
}

statp28 :anim20 {
  test 0 (4,4)-(8,12) 80000008  # is a weapon.
}
statp29 :anim21 {
  test 0 (4,4)-(8,12) 80000008  # is a weapon.
}
statP38 :anim22 {
  test 0 (0,4)-(8,12) 80000008
  testpoint off (8,16)
}
statP39 :anim23 {
  test 0 (0,4)-(8,12) 80000008
  testpoint off (8,16)
}
state37 :anim25 {
  test 0 (0,8)-(16,16) 80000008
}
state36 :anim24 {
  test 0 (0,8)-(16,16) 80000008
}


using sound(16,56) as 0  # shot
using sound(0,60) as 1  # hit
using sound(17,64) as 7  # bop

using shgob(state28:= 0 :1 1 :0) as 10  # small punch
using shgob(state29:= 0 :1 1 ~ :0) as 11
using shgob(state38:= 0 :1 1 :0) as 2   # big punch
using shgob(state39:= 0 :1 1 ~ :0) as 3
using shgob(state34 is h:= 0 :1 1 :0) as 14  # pitchenette
using shgob(state35 is h:= 0 :1 1 ~ :0) as 13
state28->nil on done
state29->nil on done
state34->nil on done
state35->nil on done



# that-hurts little star.
state19 :anim19 {
  using gravity(24,1536,4)
}
state19->state19 on fail [v5 $20 >] (v5 3 * 4 / ~ :1 0 :5 v4 :0)
state19->nil on fail[t]

using shgob(state19:=$100 :0 $100 ~ :1) as 4
using shgob(state19:=$100 ~ :0 $100 ~ :1) as 5

# bigpunch resolved into two little stars if hitting ground.
state38->state36 on fail (x4x5)
state39->state37 on fail (x4x5)
state36->nil on done
state37->nil on done
state38->nil on done
state39->nil on done

# Bilou falling and bouncing
# 4:fr 5:ir 6:jr 7:jl 8:fl 9:il 10:wr 11:wl
# v0 = xspeed ; v1 = yspeed ; v2 = testpoints
# v3 = keys : t-YXLR-v^<>-SsAB
#              +8421+8421+8421

# v4,v5 : impact speed (cf. gravity controller)
# v6    : punch power
# v7    : bops counter

# shoot a star after 3 bops 
# NOTE: the star will read v6 to know its horizontal speed.
statI4->statI4 on event0 [v3 $802 ? v6 48 > &] (v6 $400 :6 x0xax8 2/ :6)
statI5->statI5 on event0 [v3 $802 ? v6 48 > &] (v6 $400 ~ :6 x0xbx8 2/ :6)
statI4->statI4 on event0 [v3 $802 ? v6 24 > &] (x2 v6 8 - :6)
statI5->statI5 on event0 [v3 $802 ? v6 24 > &] (x3 v6 8 - :6)
statI4->statI4 on event0 [v3 $802 ? v6 4 > &] (xa v6 4 - :6)
statI5->statI5 on event0 [v3 $802 ? v6 4 > &] (xb v6 4 - :6)
statW20->statW20 on event0 [v3 $802 ? v6 40 > &] (v6 $400 :6 x0xax8 2/ :6)
statW23->statW23 on event0 [v3 $802 ? v6 40 > &] (v6 $400 ~ :6 x0xbx8 2/ :6)
statW20->statW20 on event0 [v3 $802 ? v6 4 > &] (xa v6 4 - :6)
statW23->statW23 on event0 [v3 $802 ? v6 4 > &] (xb v6 4 - :6)
statI4->statI4 on event0 [v3 $802 ?] (xe)
statI5->statI5 on event0 [v3 $802 ?] (xd)

# Did you just pressed AB mid-air ? we'll punch/shoot.
statJ6->statJ6 on event0 [v3 $802 ? v6 40 > &] (v6 $400 :6 x0xax8 2/ :6)
statJ7->statJ7 on event0 [v3 $802 ? v6 40 > &] (v6 $400 ~ :6 x0xbx8 2/ :6)
statJ6->statJ6 on event0 [v3 $802 ? v6 4 > &] (x2 v6 4 - :6)
statJ7->statJ7 on event0 [v3 $802 ? v6 4 > &] (x3 v6 4 - :6)

#turn while jumping
statF0->statF1 on event1 [v0 0 <] # speed reverted
statF1->statF0 on event1 [v0 0 >]
statF0->statF1 on event0 [v0 0 <] # speed introduced
statF1->statF0 on event0 [v0 0 >]

# bouncing on ground.
statF0->statF0 on fail [v5 800 >=] (v5 2 / ~ :1 0 :5)
statF1->statF1 on fail [v5 800 >=] (v5 2 / ~ :1 0 :5)
# landing and running.
statF0->statI4 on fail [v3 $10 &] ($fd0 :3 0 :1 0 :7)
statF1->statI5 on fail [v3 $20 &] ($fe0 :3 0 :1 0 :7)

statF0->statI4 on fail (0 :0 0 :3 0 :7)
statH15->statD14 on fail (d2 0 :0 0 :3)
statS17->statD14 on fail (d2 0 :0 0 :3)

# dodge and evade further hits.
statD14->statE12 on event0 [v3 $401 ?] (600 ~ :1 256 ~ :0)
statD14->statE10 on event0 [v3 $802 ?] (256 ~ :1 1000 ~ :0)
statD14->statI4 on done (0 :3)
statE12->statF0 on event2 [v1 0 >]
statE12->statF0 on fail (32 ~ :1)
statE10->statD14 on fail

statF1->statI5 on fail (0 :0 0 :3 0 :7)
statH16->statD13 on fail (d2 0 :0 0 :3)

# dodge and evade further hits.
statD13->statE11 on event0 [v3 $401 ?] (600 ~ :1 256 :0)
statD13->statE9 on event0 [v3 $802 ?] (256 ~ :1 1000 :0)
statD13->statI5 on done (0 :3)
statE11->statF1 on event2 [v1 0 >]
statE11->statF1 on fail (32 ~ :1)
statE9->statD13 on fail



# Bilou jumping
statJ6->statJ7 on event1 [v0 0 <]
statJ7->statJ6 on event1 [v0 0 >]
statJ6->statJ7 on event0 [v0 0 <]
statJ7->statJ6 on event0 [v0 0 >]

statI4->statJ6 on event0 [v3 $401 &] (800 ~ :1)
statI5->statJ7 on event0 [v3 $401 &] (800 ~ :1)

#stomped
statI4->statS17 on hit0 [wc 2 ?] (d2x4x5 0 :6)
statI5->statS17 on hit0 [wc 2 ?] (d2x4x5 0 :6)
statW20..25->statS17 on hit0 [wc 2 ?] (d2x4x5)
#statW23->statS17 on hit0 [wc 2 ?] (d2x4x5)

#hit
state4..7->statH15 on hit0 [wc 1 ? we 0 < &] (256 ~ :1 512 ~ :0 0 :6 x1)
state4..7->statH16 on hit0 [wc 1 ? we 0 >= &] (256 ~ :1 512  :0 0 :6 x1)
state20..25->statH15 on hit0 [wc 1 ? we 0 < &] (256 ~ :1 512 ~ :0 0 :6 x1)
state20..25->statH16 on hit0 [wc 1 ? we 0 >= &] (256 ~ :1 512  :0 0 :6 x1)
#statW20..22->statH15 on hit0 [wc 1 ?] (256 ~ :1 512 ~ :0 x1)
#statW23..25->statH16 on hit0 [wc 1 ?] (256 ~ :1 512 :0 x1)
statF0->statH15 on hit0 [wc 1 ?] (512 ~ :0 x1)
statF1->statH16 on hit0 [wc 1 ?] (512 :0 x1)

statS17->statS17 on hit0 [wc 2 ?] (d2)
statS17->statI4 on done

statJ6->statF0 on event2 [v1 0 >] (v1 0 :5)
statJ6->statF0 on fail (0 :1 0 :5)
statJ7->statF1 on event2 [v1 0 >] (v1 0 :5)
statJ7->statF1 on fail (0 :1 0 :5)

# Bilou walking
statI4->statW20 on event0 [v3 $10 &] (v3 :3)
statI4->statW23 on event0 [v3 $20 &] (v3 :3)
statW20..22->statW23 on event1 [v0 0 <]
statW23..25->statW20 on event1 [v0 0 >]
#statW20..22->statW23 on event0 [v3 $20 &] (v3 :3)
statW20..22->statJ6 on event0 [v3 $401 &] (800 ~ :1 v3 :3)

statW23..25->statW20 on event0 [v3 $10 &] (v3 :3)
statW23..25->statJ7 on event0 [v3 $401 &] (800 ~ :1 v3 :3)
statI4->statI4 on event0 

statI5->statW20 on event0 [v3 $10 &] (v3 :3)
statI5->statW23 on event0 [v3 $20 &] (v3 :3)
statI5->statI5 on event0 


statW20->statI4 on fail [v2 2 &] (0 :3)# ->P22
statW20..22->statF0 on fail [v2 1 &] (128 ~ :1 0 :5)
statW20->statI4 on fail [t]  (0 :3)

statW23->statI5 on fail [v2 2 &] (0 :3) # ->P25
statW23..25->statF1 on fail [v2 1 &] (128 ~ :1 0 :5)
statW23->statI5 on fail [t] (0 :3)
statW20..22->statI4 on event0  (0 :3)
statW23->statI5 on event0  (0 :3)
statW25->statI5 on event0  (0 :3)

statI4->statF0 on fail (0 :5)
statI5->statF1 on fail (0 :5)

#abort jumping
statJ6->statJ6 on event0 [v3 $401 !?] (v1 2 / :1)
statJ7->statJ7 on event0 [v3 $401 !?] (v1 2 / :1)

statF0->statJ6 on found0 [v3 $401 &] (600 ~ :1 v6 16+:6 v71+:7v7x7)
statF1->statJ7 on found0 [v3 $401 &] (600 ~ :1 v6 16+:6 v71+:7v7x7)
statF0->statF0 on found0 [t] (100 ~ :1 v6 8 + :6 x7)
statF1->statF1 on found0 [t] (100 ~ :1 v6 8 + :6 x7)

end
