#define v4 (Z33)  stunned_running_delay
#import v5 forced_jumps

# b0 : direction L/R
# 00x : walks ; 01x : surprised ; 10x : stunned
anim0 4 {
  spr0 0
move 1 *
  spr0 1
move 1 *
  spr0 2
move 1 *
  spr0 3
move 1 *
check
  spr0 4
move 1 *
  spr0 5
move 1 *
  spr0 6
move 1 *
  spr0 7
move 1 *
cloop
}

anim1 4 {
  spr0 4000
move -1 *
  spr0 4001
move -1 *
  spr0 4002
move -1 *
  spr0 4003
move -1 *
check
  spr0 4004
move -1 *
  spr0 4005
move -1 *
  spr0 4006
move -1 *
  spr0 4007
move -1 *
cloop
}

anim2 4 {
  spr0 0022
  delay 2
  spr0 0024
  delay 2
  spr0 0025
  delay 2
  spr0 0026
  delay 2
  spr0 0027
  delay 2
  done
}

anim3 4 {
  spr0 4022
  delay 2
  spr0 4024
  delay 2
  spr0 4025
  delay 2
  spr0 4026
  delay 2
  spr0 4027
  delay 2
  done
}

anim27 4 {
  spr0 0000
  delay 2
  done
}

anim28 4 {
  spr0 4000
  delay 2
  done
}

anim29 4 {
  spr0 0028
  delay 2
  spr0 0029
  delay 2
  spr0 002a
  delay 2
  spr0 002b
  delay 2
  done
}

# states are 
# Walk(0) -> Test(12) -> Suprised(14) -> Running (16)
# Jumping (2) , Stunned (33).


# you'll need a initial speed to be set
# otherwise the appleman won't walk.
statW0 :anim0 {
  using walker    # to the right
  selfmove
  testpoint on (13,20)
  testpoint off (16,8)
  area 0 (2,1)-(14,3) 0082
  area 1 (2,4)-(14,14) 0018 # catch weapons
  test 0 (0,0)-(80,80) 0004 # detects hero.
  test 1 (2,4)-(14,14) 0001 # hurts
}

# the testpoint makes sure the appleman stops
# while he still can move (and thus still turn
# back). It is checked at frame 4 and 8 in anim.
statW1 :anim1 {
  using walker    # to the left
  selfmove
  testpoint on (5,21)
  testpoint off (-1,8)
  area 0 (2,1)-(14,3) 0042
  area 1 (2,4)-(14,14) 0018 # catch weapons
  test 0 (0,0)-(-80,80) 0004 # detects hero.
  test 1 (2,4)-(14,14) 0001 # hurts
}

# attack. We don't further detect the player here.
statA16 :anim0 {
  using decrease (v0 by 1 to 100)
  using walker    # to the right
  selfmove
  testpoint on (13,20)
  testpoint off (16,8)
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons
  test 0 (2,4)-(14,14) 0001 # hurts
}

# the testpoint makes sure the appleman stops
# while he still can move (and thus still turn
# back). It is checked at frame 4 and 8 in anim.
statA17 :anim1 {
  using decrease (v0 by 1 to 100)
  using walker    # to the left
  selfmove
  testpoint on (5,21)
  testpoint off (-1,8)
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons
  test 0 (2,4)-(14,14) 0001 # hurts
}

# surprised to see me, Mr. Anderson ?
stat!14 :anim2 {
  using stopper
  test 0 (2,4)-(14,14) 0001 # hurts
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons

}
stat!15 :anim3 {
  using stopper
  test 0 (2,4)-(14,14) 0001 # hurts
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons
}

# jump/falls to attack the player.
statF2 :anim2 {
  using gravity(24,1536)
  test 0 (2,4)-(14,14) 0001 # hurts
  area 1 (2,4)-(14,14) 0018 # catch weapons
}
statF3 :anim3 {
  using gravity(24,1536)
  test 0 (2,4)-(14,14) 0001 # hurts
  area 1 (2,4)-(14,14) 0018 # catch weapons
}

# 'hanging on a cliff in frenzy'
# if the player can still be found, let's
# jump and attack. Otherwise, turn back
# after animation delay.
statT12 :anim27 {
  using stopper
  test 0 (0,0)-(80,80) 0004 # detects hero.
  test 1 (2,4)-(14,14) 0001 # hurts
#  test 2 (-3,-3)-(1,8) 80000080 # any other appleman ?
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons
}
statT13 :anim28 {
  using stopper
  test 0 (0,0)-(-80,80) 0004 # detects hero.
  test 1 (2,4)-(14,14) 0001 # hurts
#  test 2 (18,-3)-(15,8) 80000040 # any other appleman ?
  area 0 (2,1)-(14,3) 0002
  area 1 (2,4)-(14,14) 0018 # catch weapons
}

statZ33 :anim29 {
  using stopper
  area 1 (2,4)-(14,14) 0018 # catch weapons
}


anim4 4 {
  spr0 0f
  done
}
anim5 4 {
  spr0 400f
  done
}

statX34 :anim4 {
  using gravity(24,1536)
}
statX35 :anim5 {
  using gravity(24,1536)
}
stat!14->statA16 on done [t] (200 :0)
stat!15->statA17 on done [t] (200 ~ :0)
statW0->statT12 on fail [t] #(v0 ~ :0)
statW1->statT13 on fail [t] #(v0 ~ :0)
statA16->statT12 on fail [t]
statA17->statT13 on fail [t]

# make appleman resume to walking when 'tired'
statA16->statW0 on event0 [t]
statA17->statW1 on event0 [t]

statW1->stat!15 on found0 [t] (0 :0)
statW0->stat!14 on found0 [t] (0 :0)
statT12->statF2 on found0 [t] (200 ~ :1 200 :0)
#statT12->statF3 on found2 [t] (200 ~ :1 200 :0)
statT13->statF3 on found0 [t] (200 ~ :1 200 ~ :0)
#statT13->statF2 on found2 [t] (200 ~ :1 200 ~ :0)

# statT12->statF2 on hit1 [wc $10 ?] (200 ~ :1 200 :0)
# statT13->statF3 on hit1 [wc $10 ?] (200 ~ :1 200 ~ :0)
statT12->statF2 on done [v5 1 &] (200 ~ :1 200 :0 v5 2/ :5)
statT13->statF3 on done [v5 1 &] (200 ~ :1 200 ~ :0 v5 2/ :5)
statF2->statW0 on fail [t] (200 :0)
statF3->statW1 on fail [t] (200 ~ :0)
statT12->statW1 on done [t] (100 ~ :0 v5 2/ :5)
statT13->statW0 on done [t] (100 :0 v5 2/ :5)
statT12->statF2 on fail
statT13->statF3 on fail

statW0..1->statZ33 on hit0 [wc 2 &] (16 :4 2)
statW0->statT13 on hit0 [t] (v0 ~ :0)
statW1->statT12 on hit0 [t] (v0 ~ :0)
statT12..17->statZ33 on hit0 [t] (16 :4 2)

# stunned. Keeps that way unless your stun counter reach 0.
statZ33->statF2 on done [v4 0 =] (100 :0)
statZ33->statZ33 on done [t] (v4 1 - D :4)

# stopped by monster-player collision.
statW0->statF2 on found1  (v0 ~ :0 200 ~ :1)
statW1->statF3 on found1  (v0 ~ :0 200 ~ :1)
statA16->statF2 on found0 (v0 ~ :0 200 ~ :1)
statA17->statF3 on found0 (v0 ~ :0 200 ~ :1)


# hit by a "weapon"
state0..33->statX34 on hit1 [wc 8 ? w0 0 < &] (512 ~ :1 512 ~ :0 1)
state0..33->statX35 on hit1 [wc 8 ? w0 0 >= &] (512 ~ :1 512 :0 1)
statX34->nil on fail [c5 0 >] (d4i7)
statX35->nil on fail [c5 0 >] (d4i7)
statX34->nil on fail (d4)
statX35->nil on fail (d4)

end
